#!/bin/bash

# Direct launcher script for ParVaguesViz
# This uses what we've learned works on your system

# Get the full path to the sketch directory
SKETCH_DIR=$(cd "$(dirname "$0")" && pwd)

# Colors for terminal output
GREEN='\033[0;32m'
BLUE='\033[0;34m'
YELLOW='\033[1;33m'
NC='\033[0m' # No Color

# Print banner
echo -e "${BLUE}"
echo "██████╗  █████╗ ██████╗ ██╗   ██╗ █████╗  ██████╗ ██╗   ██╗███████╗███████╗"
echo "██╔══██╗██╔══██╗██╔══██╗██║   ██║██╔══██╗██╔════╝ ██║   ██║██╔════╝██╔════╝"
echo "██████╔╝███████║██████╔╝██║   ██║███████║██║  ███╗██║   ██║█████╗  ███████╗"
echo "██╔═══╝ ██╔══██║██╔══██╗╚██╗ ██╔╝██╔══██║██║   ██║██║   ██║██╔══╝  ╚════██║"
echo "██║     ██║  ██║██║  ██║ ╚████╔╝ ██║  ██║╚██████╔╝╚██████╔╝███████╗███████║"
echo "╚═╝     ╚═╝  ╚═╝╚═╝  ╚═╝  ╚═══╝  ╚═╝  ╚═╝ ╚═════╝  ╚═════╝ ╚══════╝╚══════╝"
echo -e "                     TIDALCYCLES VISUALIZER\n${NC}"

# Set Java options to fix module restrictions
export _JAVA_OPTIONS="--add-opens=java.desktop/sun.awt.X11=ALL-UNNAMED --add-opens=java.desktop/java.awt=ALL-UNNAMED -Djava.awt.headless=false -Dawt.useSystemAAFontSettings=on -Dswing.aatext=true"

echo -e "${YELLOW}Starting ParVaguesViz...${NC}"
echo -e "${BLUE}Controls:${NC}"
echo "  D - Toggle debug info"
echo "  H - Toggle help screen"
echo "  G - Change grid style"
echo "  F - Toggle fullscreen"
echo "  R - Reset visualization"
echo "  M - Toggle metadata display"
echo

# Launch Processing with the full path to the main sketch
echo -e "${GREEN}Launching visualizer...${NC}"
cd "$SKETCH_DIR"
processing "$SKETCH_DIR/ParVaguesViz.pde"
